#!/usr/bin/env python
# -*- coding: euc-jp -*-

##
#  @file CORBA_RTCUtil.py
#  @brief CORBA RTC utility
#  @date $Date: 2016/01/08 $
#  @author Nobuhiko Miyamoto
# 

import OpenRTM_aist
import OpenRTM_aist.RTObject
from omniORB import CORBA
import RTC


##
# @if jp
#
# @brief ݡͥȤΥץѥƥ
#
# 
# @param rtc RTݡͥ
# @return ݡͥȤΥץѥƥ
#
# @else
#
# @brief 
# @param rtc
# @return 
#
# @endif
# coil::Properties get_component_profile(const RTC::RTObject_ptr rtc)
def get_component_profile(rtc):
  prop = OpenRTM_aist.Properties()
  if CORBA.is_nil(rtc):
    return prop
  prof = rtc.get_component_profile()
  OpenRTM_aist.NVUtil.copyToProperties(prop, prof.properties)
  return prop




##
# @if jp
#
# @brief ݡͥȤΥ֥ȥե󥹤¸ߤƤ뤫Ƚ
#
# 
# @param rtc RTݡͥ
# @return True:¸False:λѤ
#
# @else
#
# @brief 
# @param rtc RTݡͥ
# @return 
#
# @endif
def is_existing(rtc):
  try:
    if rtc._non_existent():
      return False
    return True
  except CORBA.SystemException:
    return False


##
# @if jp
#
# @brief RTCǥեȤμ¹ԥƥȤalive֤Ƚꤹ
#
# @param rtc RTݡͥ
# @return True:alive
# 
# @param 
#
# @else
#
# @brief 
# @param 
#
# @endif
def is_alive_in_default_ec(rtc):
  ec = get_actual_ec(rtc)
  if CORBA.is_nil(ec):
    return False
  return rtc.is_alive(ec)


##
# @if jp
#
# @brief RTݡͥȤ˴Ϣդ¹ԥƥȤꤷIDμ¹ԥƥȤ
#
# 
# @param rtc оݤRTݡͥ
# @param ec_id ¹ԥƥȤID
# @return ¹ԥƥȤΥ֥ȥե
#
# @else
#
# @brief 
# @param rtc
# @param ec_id
# @return
#
# @endif
# RTC::ExecutionContext_var get_actual_ec(const RTC::RTObject_ptr rtc,RTC::UniqueId ec_id = 0)
def get_actual_ec(rtc, ec_id=0):
  if ec_id < 0:
    return RTC.ExecutionContext._nil
  if CORBA.is_nil(rtc):
    return RTC.ExecutionContext._nil
  if ec_id < OpenRTM_aist.RTObject.ECOTHER_OFFSET:
    eclist = rtc.get_owned_contexts()
    if ec_id >= len(eclist):
      return RTC.ExecutionContext._nil
    
    if CORBA.is_nil(eclist[ec_id]):
      return RTC.ExecutionContext._nil
    return eclist[ec_id]
  elif ec_id >= OpenRTM_aist.RTObject.ECOTHER_OFFSET:
    pec_id = ec_id - OpenRTM_aist.RTObject.ECOTHER_OFFSET
    eclist = rtc.get_participating_contexts()
    if pec_id >= len(eclist):
      return RTC.ExecutionContext._nil
    if CORBA.is_nil(eclist[pec_id]):
      return RTC.ExecutionContext._nil
    return eclist[pec_id]

    


##
# @if jp
#
# @brief оݤRTݡͥȤꤷ¹ԥƥȤID 
#
# 
# @param rtc оݤRTݡͥ
# @param ec ¹ԥƥ
# @return ¹ԥƥȤID
# ꤷ¹ԥƥȤRTݡͥȤ˴ϢդƤʤä-1֤
#
# @else
#
# @brief 
# @param 
#
# @endif
def get_ec_id(rtc, ec):
  if CORBA.is_nil(rtc):
    return -1
  if CORBA.is_nil(ec):
    return -1
  
  eclist_own = rtc.get_owned_contexts()
  
  count = 0
  for e in eclist_own:
    if not CORBA.is_nil(e):
      if e._is_equivalent(ec):
        return count
    count += 1
  eclist_pec = rtc.get_participating_contexts()
  count = 0
  for e in eclist_pec:
    if not CORBA.is_nil(e):
      if e._is_equivalent(ec):
        return count+OpenRTM_aist.RTObject.ECOTHER_OFFSET
    count += 1
  return -1
  


##
# @if jp
#
# @brief RTCꤷ¹ԥƥȤǥƥ١󤹤
#
# 
# @param rtc оݤRTݡͥ
# @param ec_id ¹ԥƥȤID
# @return RTCECΥ֥ȥե󥹤nilξBAD_PARAMETER֤
# nilǤϤʤactivate_componentؿ֤ͤRTC_OKξϥƥ١
#
# @else
#
# @brief 
# @param rtc
# @param ec_id
# @return 
#
# @endif
# RTC::ReturnCode_t activate(RTC::RTObject_ptr rtc, RTC::UniqueId ec_id = 0)
def activate(rtc, ec_id=0):
  if CORBA.is_nil(rtc):
    return RTC.BAD_PARAMETER
  ec = get_actual_ec(rtc, ec_id)
  if CORBA.is_nil(ec):
    return RTC.BAD_PARAMETER
  return ec.activate_component(rtc)
  

##
# @if jp
#
# @brief RTCꤷ¹ԥƥȤ󥢥ƥ١󤹤
#
# 
# @param rtc оݤRTݡͥ
# @param ec_id ¹ԥƥȤID
# @return RTCECΥ֥ȥե󥹤nilξBAD_PARAMETER֤
# nilǤϤʤdeactivate_componentؿ֤ͤRTC_OKξ󥢥ƥ١
#
# @else
#
# @brief 
# @param rtc
# @param ec_id
# @return 
#
# @endif
# RTC::ReturnCode_t deactivate(RTC::RTObject_ptr rtc, RTC::UniqueId ec_id = 0)
def deactivate(rtc, ec_id=0):
  if CORBA.is_nil(rtc):
    return RTC.BAD_PARAMETER
  ec = get_actual_ec(rtc, ec_id)
  if CORBA.is_nil(ec):
    return RTC.BAD_PARAMETER
  return ec.deactivate_component(rtc)

##
# @if jp
#
# @brief RTCꤷ¹ԥƥȤǥꥻåȤ
#
# 
# @param rtc оݤRTݡͥ
# @param ec_id ¹ԥƥȤID
# @return RTCECΥ֥ȥե󥹤nilξBAD_PARAMETER֤
# nilǤϤʤreset_componentؿ֤ͤRTC_OKξϥꥻåȤ
#
# @else
#
# @brief 
# @param rtc
# @param ec_id
# @return 
#
# @endif
# RTC::ReturnCode_t reset(RTC::RTObject_ptr rtc, RTC::UniqueId ec_id = 0)
def reset(rtc, ec_id=0):
  if CORBA.is_nil(rtc):
    return RTC.BAD_PARAMETER
  ec = get_actual_ec(rtc, ec_id)
  if CORBA.is_nil(ec):
    return RTC.BAD_PARAMETER
  return ec.reset_component(rtc)

##
# @if jp
#
# @brief оݤRTݡͥȤλꤷ¹ԥƥȤǤξ֤
#
#
# @param rtc оݤRTݡͥ
# @param ec_id ¹ԥƥȤID
# @return 1ܤͤȤrtcecnilξFalse֤ʳξTrue֤
# 2ܤͤȤƾ֤֤
# 
#
# @else
#
# @brief
# @param rtc
# @param ec_id
# @return 
#
# @endif
def get_state(rtc, ec_id=0):
  if CORBA.is_nil(rtc):
    return False, RTC.CREATED_STATE
  ec = get_actual_ec(rtc, ec_id)
  if CORBA.is_nil(ec):
    return False, RTC.CREATED_STATE
  state = ec.get_component_state(rtc)
  return True, state

##
# @if jp
#
# @brief оݤRTݡͥȤλꤷ¹ԥƥȤINACTIVE֤ɤȽ
#
# 
# @param rtc оݤRTݡͥ
# @param ec_id ¹ԥƥȤID
# @return INACTIVE֤λTrueʳFalse
# rtcecnilξFalse֤
#
# @else
#
# @brief 
# @param rtc 
# @param ec_id
# @return 
#
# @endif
def is_in_inactive(rtc, ec_id=0):
  ret, state = get_state(rtc, ec_id)
  if ret:
    if state == RTC.INACTIVE_STATE:
      return True
  return False

##
# @if jp
#
# @brief оݤRTݡͥȤλꤷ¹ԥƥȤACTIVE֤ɤȽ
#
# 
# @param rtc оݤRTݡͥ
# @param ec_id ¹ԥƥȤID
# @return ACTIVE֤λTrueʳFalse
# rtcecnilξFalse֤
#
# @else
#
# @brief 
# @param rtc 
# @param ec_id
# @return 
#
# @endif
def is_in_active(rtc, ec_id=0):
  ret, state = get_state(rtc, ec_id)
  if ret:
    if state == RTC.ACTIVE_STATE:
      return True
  return False

##
# @if jp
#
# @brief оݤRTݡͥȤλꤷ¹ԥƥȤERROR֤ɤȽ
#
# 
# @param rtc оݤRTݡͥ
# @param ec_id ¹ԥƥȤID
# @return ERROR֤λTrueʳFalse
# rtcecnilξFalse֤
#
# @else
#
# @brief 
# @param rtc 
# @param ec_id
# @return 
#
# @endif
def is_in_error(rtc, ec_id=0):
  ret, state = get_state(rtc, ec_id)
  if ret:
    if state == RTC.ERROR_STATE:
      return True
  return False



##
# @if jp
#
# @brief RTCΥǥեȤμ¹ԥƥȤμ¹Լ
#
# 
# @param rtc RTݡͥ
# @return ¹Լ
#
# @else
#
# @brief 
# @param ec 
# @return
#
# @endif
def get_default_rate(rtc):
  ec = get_actual_ec(rtc)
  return ec.get_rate()


##
# @if jp
#
# @brief RTCΥǥեȤμ¹ԥƥȤμ¹Լꤹ
#
# 
# @param rtc RTݡͥ
# @param rate ¹Լ
# @return set_rateؿ֤ͤ
# RTC_OK꤬
#
# @else
#
# @brief 
# @param ec
#
# @endif
def set_default_rate(rtc, rate):
  ec = get_actual_ec(rtc)
  return ec.set_rate(rate)


##
# @if jp
#
# @brief RTCλIDμ¹ԥƥȤμ
#
# 
# @param rtc оݤRTݡͥ
# @param ec_id μ¹ԥƥȤID
# @return ¹Լ
#
# @else
#
# @brief 
# @param ec
# @return
#
# @endif
def get_current_rate(rtc, ec_id):
  ec = get_actual_ec(rtc, ec_id)
  return ec.get_rate()


##
# @if jp
#
# @brief RTCλIDμ¹ԥƥȤμ
#
# 
# @param rtc оݤRTݡͥ
# @param ec_id μ¹ԥƥȤID
# @param rate ¹Լ
# @return set_rateؿ֤ͤ
# RTC_OK꤬
#
# @else
#
# @brief 
# @param  
#
# @endif
def set_current_rate(rtc, ec_id, rate):
  ec = get_actual_ec(rtc, ec_id)
  return ec.set_rate(rate)


##
# @if jp
#
# @brief оݤRTCΥǥեȤμ¹ԥƥȤ˻RTCϢդ
#
# 
# @param localcomp оݤRTݡͥ
# @param othercomp ¹ԥƥȤ˴ϢդRTݡͥ
# @return ecμ˼ԤBAD_PARAMETER֤
# ǤʤaddComponentؿ֤ͤRTC_OK³
#
# @else
#
# @brief 
# @param 
#
# @endif
def add_rtc_to_default_ec(localcomp, othercomp):
  if CORBA.is_nil(othercomp):
    return RTC.BAD_PARAMETER
  ec = get_actual_ec(localcomp)
  if CORBA.is_nil(ec):
    return RTC.BAD_PARAMETER
  return ec.add_component(othercomp)


##
# @if jp
#
# @brief оݤRTCΥǥեȤμ¹ԥƥȤλRTCؤδϢդ
#
# 
# @param localcomp оݤRTݡͥ
# @param othercomp ¹ԥƥȤȤδϢդRTݡͥ
# @return ecμ˼ԤBAD_PARAMETER֤
# ǤʤremoveComponentؿ֤ͤRTC_OKǲ
#
# @else
#
# @brief 
# @param 
#
# @endif
def remove_rtc_to_default_ec(localcomp, othercomp):
  if CORBA.is_nil(othercomp):
    return RTC.BAD_PARAMETER
  ec = get_actual_ec(localcomp)
  if CORBA.is_nil(ec):
    return RTC.BAD_PARAMETER
  return ec.remove_component(othercomp)


##
# @if jp
#
# @brief RTCΥǥեȤμ¹ԥƥȤ˻äƤRTCΥꥹȤ
# ¹ԥƥȤnilξ϶ΥꥹȤ֤
#
# 
# @param rtc RTݡͥ
# @return RTCΥꥹ
#
# @else
#
# @brief 
# @param ec
# @return 
#
# @endif
def get_participants_rtc(rtc):
  ec = get_actual_ec(rtc)
  if CORBA.is_nil(ec):
    return []
  profile = ec.get_profile()
  return profile.participants


##
# @if jp
#
# @brief ꤷRTCݻݡȤ̾
#
# 
# @param rtc оݤRTݡͥ
# @return ݡ̾Υꥹ
#
# @else
#
# @brief 
# @param rtc
# @return
#
# @endif
def get_port_names(rtc):
  names = []
  if CORBA.is_nil(rtc):
    return names
  ports = rtc.get_ports()
  for p in ports:
    pp = p.get_port_profile()
    s = pp.name
    names.append(s)
  return names


##
# @if jp
#
# @brief ꤷRTCݻ륤ݡȤ̾
#
# 
# @param rtc оݤRTݡͥ
# @return ݡ̾Υꥹ
#
# @else
#
# @brief 
# @param rtc
# @return
#
# @endif
def get_inport_names(rtc):
  names = []
  if CORBA.is_nil(rtc):
    return names
  
  ports = rtc.get_ports()
  for p in ports:
    pp = p.get_port_profile()
    prop = OpenRTM_aist.Properties()
    OpenRTM_aist.NVUtil.copyToProperties(prop, pp.properties)
    if prop.getProperty("port.port_type") == "DataInPort":
      s = pp.name
      names.append(s)
  return names


##
# @if jp
#
# @brief ꤷRTCݻ륢ȥݡȤ̾
#
# 
# @param rtc оݤRTݡͥ
# @return ݡ̾Υꥹ
#
# @else
#
# @brief 
# @param rtc
# @return
#
# @endif
def get_outport_names(rtc):
  names = []
  if CORBA.is_nil(rtc):
    return names
  
  ports = rtc.get_ports()
  for p in ports:
    pp = p.get_port_profile()
    prop = OpenRTM_aist.Properties()
    OpenRTM_aist.NVUtil.copyToProperties(prop, pp.properties)
    if prop.getProperty("port.port_type") == "DataOutPort":
      s = pp.name
      names.append(s)
  return names



##
# @if jp
#
# @brief ꤷRTCݻ륵ӥݡȤ̾
#
# 
# @param rtc оݤRTݡͥ
# @return ݡ̾Υꥹ
#
# @else
#
# @brief 
# @param rtc
# @return
#
# @endif
def get_svcport_names(rtc):
  names = []
  if CORBA.is_nil(rtc):
    return names
  
  ports = rtc.get_ports()
  for p in ports:
    pp = p.get_port_profile()
    prop = OpenRTM_aist.Properties()
    OpenRTM_aist.NVUtil.copyToProperties(prop, pp.properties)
    if prop.getProperty("port.port_type") == "CorbaPort":
      s = pp.name
      names.append(s)
  return names


##
# @if jp
#
# @brief оݤRTCꤷ̾ΥݡȤ
#
# 
# @param rtc RTݡͥ
# @param port_name ݡ̾
# @return ݡ
#
# @else
#
# @brief 
# @param rtc 
# @param port_name
# @return 
#
# @endif
#
# RTC::PortService_var get_port_by_name(const RTC::RTObject_ptr rtc, std::string port_name)
def get_port_by_name(rtc, port_name):
  if CORBA.is_nil(rtc):
    return RTC.PortService._nil
  ports = rtc.get_ports()
  for p in ports:
    pp = p.get_port_profile()
    s = pp.name
    
    if port_name == s:
      return p

  return RTC.PortService._nil



##
# @if jp
#
# @brief ꤷݡȤݻƤ륳ͥ̾ΥꥹȤ
#
# 
# @param port оݤΥݡ
# @return ͥ̾Υꥹ
#
# @else
#
# @brief 
# @param port
# @return
#
# @endif
def get_connector_names_by_portref(port):
  names = []
  if CORBA.is_nil(port):
    return names
  conprof = port.get_connector_profiles()
  for c in conprof:
    names.append(c.name)
  return names

##
# @if jp
#
# @brief оݤRTCλꤷݡȤΥͥ̾ΥꥹȤ
#
# @param rtc RTݡͥ
# @param port_name ݡ̾
# @return ͥ̾Υꥹ
#
# @else
#
# @brief
# @param rtc
# @param port_name
# @return
#
# @endif
def get_connector_names(rtc, port_name):
  names = []
  port = get_port_by_name(rtc, port_name)
  if CORBA.is_nil(port):
    return names
  conprof = port.get_connector_profiles()
  for c in conprof:
    names.append(c.name)
  return names


  


##
# @if jp
#
# @brief ꤷݡȤݻƤ륳ͥIDΥꥹȤ
#
# 
# @param port оݤΥݡ
# @return ͥIDΥꥹ
#
# @else
#
# @brief 
# @param port
# @return
#
# @endif
def get_connector_ids_by_portref(port):
  ids = []
  if CORBA.is_nil(port):
    return ids
  conprof = port.get_connector_profiles()
  for c in conprof:
    ids.append(c.connector_id)
  return ids




##
# @if jp
#
# @brief оݤRTCλꤷݡȤΥͥIDΥꥹȤ
#
# 
# @param rtc RTݡͥ
# @param port_name ݡ̾
# @return ͥIDΥꥹ
#
# @else
#
# @brief 
# @param rtc
# @param port_name
# @return
#
# @endif
def get_connector_ids(rtc, port_name):
  ids = []
  port = get_port_by_name(rtc, port_name)
  if CORBA.is_nil(port):
    return ids
  conprof = port.get_connector_profiles()
  for c in conprof:
    ids.append(c.connector_id)
  return ids

##
# @if jp
#
# @brief ꤷݡȤ³뤿Υͥץե
#
# 
# @param name ͥ̾
# @param prop_arg 
# @param port0 оݤΥݡ1
# @param port1 оݤΥݡ2
# @return ͥץե
#
# @else
#
# @brief 
# @param name
# @param prop_arg
# @param port0
# @param port1
# @return
#
# @endif
# RTC::ConnectorProfile_var create_connector(const std::string name,const coil::Properties prop_arg,const RTC::PortService_ptr port0,const RTC::PortService_ptr port1)
def create_connector(name, prop_arg, port0, port1):
  prop = prop_arg
  if CORBA.is_nil(port1):
    conn_prof = RTC.ConnectorProfile(name, "", [port0],[])
  else:
    conn_prof = RTC.ConnectorProfile(name, "", [port0, port1],[])



  if not str(prop.getProperty("dataport.dataflow_type")):
    prop.setProperty("dataport.dataflow_type","push")

 

  if not str(prop.getProperty("dataport.interface_type")):
    prop.setProperty("dataport.interface_type","corba_cdr")


  conn_prof.properties = []
  OpenRTM_aist.NVUtil.copyFromProperties(conn_prof.properties, prop)
  
  return conn_prof
  

  
                                            

##
# @if jp
#
# @brief ꤷݡƱΤ³Ƥ뤫Ƚ
#
# 
# @param localport оݤΥݡ1
# @param otherport оݤΥݡ2
# @return True: ³ѤߡFalse: ̤³
#
# @else
#
# @brief 
# @param name
# @param prop_arg
# @param port0
# @param port1
# @return
#
# @endif

def already_connected(localport, otherport):
  conprof = localport.get_connector_profiles()
  for c in conprof:
    for p in c.ports:
      if p._is_equivalent(otherport):
        return True

  return False


##
# @if jp
#
# @brief ꤷݡȤ³
#
# 
# @param name ͥ̾
# @param prop 
# @param port0 оݤΥݡ1
# @param port1 оݤΥݡ2
# @return ݡȤΥ֥ȥե󥹤nilξBAD_PARAMETER֤
# nilǤϤʤport0.connectؿ֤ͤRTC_OKξ³
#
# @else
#
# @brief 
# @param name
# @param prop
# @param port0
# @param port1
# @return 
#
# @endif
# RTC::ReturnCode_t connect(const std::string name,const coil::Properties prop,const RTC::PortService_ptr port0,const RTC::PortService_ptr port1)
def connect(name, prop, port0, port1):
  if CORBA.is_nil(port0):
    return RTC.BAD_PARAMETER
  #if CORBA.is_nil(port1):
  #  return RTC.BAD_PARAMETER
  if not CORBA.is_nil(port1):
    if port0._is_equivalent(port1):
      return RTC.BAD_PARAMETER
  cprof = create_connector(name, prop, port0, port1)
  return port0.connect(cprof)[0]



##
# @if jp
#
# @brief ꤷݡȤȻꤷꥹΥݡƤ³
#
# 
# @param name ͥ̾
# @param prop 
# @param port оݤΥݡ
# @param target_ports оݤΥݡȤΥꥹ
# @return Ƥ³RTC_OK֤
# connectؿRTC_OKʳ֤BAD_PARAMETER֤
#
#
# @else
#
# @brief 
# @param name
# @param prop
# @param port0
# @param port1
# @return 
#
# @endif
# RTC::ReturnCode_t connect_multi(const std::string name,const coil::Properties prop,const RTC::PortService_ptr port,RTC::PortServiceList_var& target_ports)
def connect_multi(name, prop, port, target_ports):
  ret = RTC.RTC_OK
  if CORBA.is_nil(port):
    return RTC.BAD_PARAMETER
  for p in target_ports:
    if CORBA.is_nil(p):
      continue
    if p._is_equivalent(port):
      continue
    if already_connected(port, p):
      continue
    if RTC.RTC_OK != connect(name, prop, port, p):
      ret = RTC.BAD_PARAMETER

  return ret


##
# @if jp
# @class find_port
# @brief ݡȤ̾鸡
#
# @else
# @class find_port
# @brief 
#
# @endif
#
class find_port:
  ##
  # @if jp
  #
  # @brief 󥹥ȥ饯
  # ݡ̾ꤹ
  #
  # 
  # @param self
  # @param name ݡ̾
  #
  # @else
  #
  # @brief 
  # @param self
  # @param name
  #
  # @endif
  # find_port(const std::string name)
  def __init__(self, name):
    self._name = name
  ##
  # @if jp
  #
  # @brief оݤΥݡȤ̾Ȼꤷݡ̾פ뤫Ƚ
  #
  # 
  # @param self
  # @param p оݤΥݡ
  # @return True: ̾סFalse:̾԰
  #
  # @else
  #
  # @brief 
  # @param self
  # @param p
  # @return
  #
  # @endif
  # bool operator()(RTC::PortService_var p)
  def __call__(self, p):
    prof = p.get_port_profile()
    c = prof.name
    
    return (self._name == c)
  
##
# @if jp
#
# @brief оݤRTCλꤷ̾ΥݡȤ³
#
# 
# @param name ͥ̾
# @param prop 
# @param rtc0 оݤRTCݡͥ1
# @param portName0 оݤΥݡ̾1
# @param rtc1 оݤRTCݡͥ2
# @param portName1 оݤRTCݡͥ2
# @return RTCݡȤnilξBAD_PARAMETER֤
# nilǤϤʤport0.connectؿ֤ͤRTC_OKξ³
#
# @else
#
# @brief 
# @param name
# @param prop_arg
# @param port0
# @param port1 
#
# @endif
#
# RTC::ReturnCode_t connect_by_name(std::string name, coil::Properties prop,RTC::RTObject_ptr rtc0,const std::string port_name0,RTC::RTObject_ptr rtc1,const std::string port_name1)
def connect_by_name(name, prop, rtc0, port_name0, rtc1, port_name1):
  if CORBA.is_nil(rtc0):
    return RTC.BAD_PARAMETER
  if CORBA.is_nil(rtc1):
    return RTC.BAD_PARAMETER

  port0 = get_port_by_name(rtc0, port_name0)
  if CORBA.is_nil(port0):
    return RTC.BAD_PARAMETER

  port1 = get_port_by_name(rtc1, port_name1)
  if CORBA.is_nil(port1):
    return RTC.BAD_PARAMETER

  return connect(name, prop, port0, port1)


##
# @if jp
#
# @brief ΥͥǤ
#
# 
# @param connector_prof ͥץե
# @return ͥץեݻƤݡȤΥ֥ȥե󥹤nilξBAD_PARAMETER֤
# nilǤϤʤports[0].disconnectؿ֤ͤRTC_OKξǤ
#
# @else
#
# @brief 
# @param connector_prof
# @return
#
# @endif
def disconnect(connector_prof):
  ports = connector_prof.ports
  return disconnect_by_portref_connector_id(ports[0], connector_prof.connector_id)
  
  

##
# @if jp
#
# @brief оݤΥݡȤǻꤷ̾Υͥ
#
# 
# @param port_ref оݤΥݡ
# @param conn_name ͥ̾
# @return portnilξBAD_PARAMETER֤
# nilǤϤʤdisconnectؿ֤ͤRTC_OKξǤ
#
# @else
#
# @brief 
# @param port_ref 
# @param conn_name 
# @return 
#
# @endif
def disconnect_by_portref_connector_name(port_ref, conn_name):
  if CORBA.is_nil(port_ref):
    return RTC.BAD_PARAMETER
  conprof = port_ref.get_connector_profiles()
  for c in conprof:
    if c.name == conn_name:
      return disconnect(c)
  return RTC.BAD_PARAMETER



##
# @if jp
#
# @brief оݤ̾ΥݡȤǻꤷ̾Υͥ
#
# 
# @param port_name оݤΥݡ̾
# @param conn_name ͥ̾
# @return port¸ߤʤBAD_PARAMETER֤
# nilǤϤʤdisconnectؿ֤ͤRTC_OKξǤ
#
# @else
#
# @brief 
# @param 
#
# @endif
def disconnect_by_portname_connector_name(port_name, conn_name):
  port_ref = get_port_by_url(port_name)
  if CORBA.is_nil(port_ref):
    return RTC.BAD_PARAMETER
  
  conprof = port_ref.get_connector_profiles()
  for c in conprof:
    if c.name == conn_name:
      return disconnect(c)
    
  return RTC.BAD_PARAMETER


##
# @if jp
#
# @brief оݤΥݡȤǻꤷIDΥͥ
#
# 
# @param port оݤΥݡ
# @param name ͥID
# @return portnilξBAD_PARAMETER֤
# nilǤϤʤdisconnectؿ֤ͤRTC_OKξǤ
#
# @else
#
# @brief 
# @param 
#
# @endif
def disconnect_by_portref_connector_id(port_ref, conn_id):
  if CORBA.is_nil(port_ref):
    return RTC.BAD_PARAMETER
  return port_ref.disconnect(conn_id)


##
# @if jp
#
# @brief оݤ̾ΥݡȤǻꤷIDΥͥ
#
# 
# @param port_name оݤΥݡ̾
# @param name ͥID
# @return port¸ߤʤBAD_PARAMETER֤
# nilǤϤʤdisconnectؿ֤ͤRTC_OKξǤ
#
# @else
#
# @brief 
# @param port_name 
# @param name 
# @return 
#
# @endif
def disconnect_by_portname_connector_id(port_name, conn_id):
  port_ref = get_port_by_url(port_name)
  if port_ref == RTC.PortService._nil:
    return RTC.BAD_PARAMETER
  
  return port_ref.disconnect(conn_id)
  

##
# @if jp
#
# @brief оݤΥݡȤΥͥ
#
# 
# @param port_ref ݡȤΥ֥ȥե
# @return portnilξBAD_PARAMETER֤
# ǤǤRTC_OK֤
#
# @else
#
# @brief 
# @param port
# @return 
#
# @endif
def disconnect_all_by_ref(port_ref):
  if CORBA.is_nil(port_ref):
    return RTC.BAD_PARAMETER
  return port_ref.disconnect_all()


##
# @if jp
#
# @brief ݡ̾ΥݡȤΥͥ
#
# 
# @param port_name ݡ̾
# @return port¸ߤʤBAD_PARAMETER֤
# ǤǤRTC_OK֤
#
# @else
#
# @brief 
# @param port
# @return 
#
# @endif
def disconnect_all_by_name(port_name):
  port_ref = get_port_by_url(port_name)
  if port_ref == RTC.PortService._nil:
    return RTC.BAD_PARAMETER
  return port_ref.disconnect_all()


##
# @if jp
#
# @brief ꤷ̾ΥݡȤ
#
# 
# @param port_name ݡ̾
# @return ݡȤΥ֥ȥե
# port¸ߤʤnil֤
#
# @else
#
# @brief 
# @param port_name
# @return 
#
# @endif
def get_port_by_url(port_name):
  mgr = OpenRTM_aist.Manager.instance()
  nm = mgr.getNaming()
  p = port_name.split(".")
  if len(p) < 2:
    return RTC.PortService._nil
  
  rtcs = nm.string_to_component(port_name.rstrip("."+p[-1]))
  
  if len(rtcs) < 1:
    return RTC.PortService._nil
  pn = port_name.split("/")
  
  return get_port_by_name(rtcs[0],pn[-1])

##
# @if jp
#
# @brief оݥݡȤ³ƤݡȤǻꤷݡ̾Ȱפ
#
# 
# @param localport оݤΥݡ
# @param othername ³Ƥݡ̾
# @return ݡȤnilξ硢localport̾othernameפ硢³ƤݡȤ̾othernameȰפΤʤBAD_PARAMETER֤
# 嵭ξƤϤޤʤdisconnectؿ֤ͤRTC_OKξǤ
#
# @else
#
# @brief 
# @param 
#
# @endif
def disconnect_by_port_name(localport, othername):
  if CORBA.is_nil(localport):
    return RTC.BAD_PARAMETER
  prof = localport.get_port_profile()
  if prof.name == othername:
    return RTC.BAD_PARAMETER
  
  conprof = localport.get_connector_profiles()
  for c in conprof:
    for p in c.ports:
      if not CORBA.is_nil(p):
        pp = p.get_port_profile()
        if pp.name == othername:
          return disconnect(c)
  return RTC.BAD_PARAMETER


##
# @if jp
#
# @brief оݤRTݡͥȤλꤷ̾Υե졼󥻥åȤkey-valueǼ
#
# 
# @param rtc оݤRTݡͥ
# @param conf_name ե졼󥻥å̾
# @return ե졼󥻥å
#
# @else
#
# @brief 
# @param rtc 
# @param conf_name 
# @return 
#
# @endif
def get_configuration(rtc, conf_name):
  conf = rtc.get_configuration()
  
  confset = conf.get_configuration_set(conf_name)
  confData = confset.configuration_data
  prop = OpenRTM_aist.Properties()
  OpenRTM_aist.NVUtil.copyToProperties(prop, confData)
  return prop


##
# @if jp
#
# @brief ꤷե졼󥻥å̾ѥ᡼̾Υե졼ѥ᡼
#
# 
# @param rtc RTݡͥ
# @param confset_name ե졼󥻥å̾
# @param value_name ѥ᡼̾
# @return ѥ᡼
#
# @else
#
# @brief 
# @param rtc
# @param confset_name
# @param value_name
# @param ret
# @return
#
# @endif
def get_parameter_by_key(rtc, confset_name, value_name):
  conf = rtc.get_configuration()
  
    
  confset = conf.get_configuration_set(confset_name)
  confData = confset.configuration_data
  prop = OpenRTM_aist.Properties()
  OpenRTM_aist.NVUtil.copyToProperties(prop, confData)
  return prop.getProperty(value_name)
    
  


##
# @if jp
#
# @brief оݤRTCΥƥ֤ʥե졼󥻥å̾
#
# @param rtc RTݡͥ
# @return ե졼󥻥å̾
# ե졼μ˼Ԥ϶ʸ֤
# 
# @param 
#
# @else
#
# @brief 
# @param rtc
# @return 
#
# @endif
def get_active_configuration_name(rtc):
  conf = rtc.get_configuration()
  confset = conf.get_active_configuration_set()
  return confset.id

##
# @if jp
#
# @brief ƥ֤ʥե졼󥻥åȤkey-valueǼ
#
# 
# @param rtc оݤRTݡͥ
# @return ƥ֤ʥե졼󥻥å
#
# @else
#
# @brief 
# @param rtc
# @return
#
# @endif
def get_active_configuration(rtc):
  conf = rtc.get_configuration()

  confset = conf.get_active_configuration_set()
  confData = confset.configuration_data
  prop = OpenRTM_aist.Properties()
  OpenRTM_aist.NVUtil.copyToProperties(prop, confData)
  return prop
    




##
# @if jp
#
# @brief ե졼ѥ᡼
#
#
# @param rtc оݤRTݡͥ
# @param confset_name ե졼󥻥å̾
# @param value_name ѥ᡼̾
# @param value ѥ᡼
# @return True:False:˼
#
# @else
#
# @brief
# @param rtc
# @param confset_name
# @param value_name
# @param value
# @return
#
# @endif
def set_configuration(rtc, confset_name, value_name, value):
  conf = rtc.get_configuration()
  
  confset = conf.get_configuration_set(confset_name)

  set_configuration_parameter(conf, confset, value_name, value)
  
  conf.activate_configuration_set(confset_name)
  return True


##
# @if jp
#
# @brief ƥ֤ʥե졼󥻥åȤΥѥ᡼
#
#
# @param rtc оݤRTݡͥ
# @param value_name ѥ᡼̾
# @param value ѥ᡼
# @return True:False:˼
#
# @else
#
# @brief
# @param rtc 
# @param confset_name
# @param value_name
# @param value
# @return
#
# @endif
def set_active_configuration(rtc, value_name, value):
  conf = rtc.get_configuration()
  
  confset = conf.get_active_configuration_set()
  set_configuration_parameter(conf, confset, value_name, value)
   
  conf.activate_configuration_set(confset.id)
  return True


##
# @if jp
#
# @brief ե졼ѥ᡼
#
#
# @param conf ե졼
# @param confset ե졼󥻥å
# @param value_name ѥ᡼̾
# @param value ѥ᡼
# @return True:False:˼
#
# @else
#
# @brief
# @param conf
# @param confset
# @param value_name
# @param value
# @return
#
# @endif
def set_configuration_parameter(conf, confset, value_name, value):
  confData = confset.configuration_data
  prop = OpenRTM_aist.Properties()
  OpenRTM_aist.NVUtil.copyToProperties(prop, confData)
  prop.setProperty(value_name,value)
  OpenRTM_aist.NVUtil.copyFromProperties(confData,prop)
  confset.configuration_data = confData
  conf.set_configuration_set_values(confset)
  return True
  